%bcond_without ExtUtils

Name:         gnormalize
Version:      0.63
Release:      10%{?dist}
Group:        Applications/Multimedia
Summary:      An audio converter, a ripper, an encoder, a tag editor and an audio player
License:      GPLv2+
URL:          http://gnormalize.sourceforge.net
Source:       http://prdownloads.sourceforge.net/gnormalize/%{name}-%{version}.tar.gz
Source1:      http://www.rarewares.org/files/others/WaveGain-1.2.6.tar.gz
Source2:      http://search.cpan.org/CPAN/authors/id/D/DO/DOUGM/Audio-CD-0.04.tar.gz
Patch0:       gnormalize-Audio-CD.patch   
Patch1:       gnormalize-0.63-mpc.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: lzma, libcdaudio-devel
%{?with_ExtUtils:BuildRequires: perl-ExtUtils-MakeMaker}
Requires:     wavegain, cdparanoia, perl >= 5.8, lame
Requires:     gtk2 >= 2.6.0, perl-Gtk2 >= 1.050
Requires:     perl(MP3::Info), perl(Gtk2), perl(Gtk2::Pango), perl(CDDB_get)
Requires:     perl(Encode), perl(Fcntl), perl(POSIX), perl(File::Find), perl(Glib)    
Requires:     alsa-utils, flac, faac, mplayer, vorbis-tools
Requires:     mac, flac123, mpg123
Requires:     musepack-tools >= sv8
#Requires:    mppdec, mppenc
Provides:     wavegain = 1.2.6 
Provides:     perl-Audio-CD = 0.04

%description
gnormalize is an audio converter and CD ripper, which allows
the application of ReplayGain normalization algorithms.
It is also an audio player and a metadata (tag) editor,
based on gtk2-perl under GNU/Linux.

gnormalize decodes the MP3, MP4 (or M4A or AAC), MPC (or MPP or MP+)
OGG, APE or FLAC files to wave, then normalizes the WAV to a targeted 
volume level and re-encodes it. The normalization is peformed through
'wavegain', by using the accurate gain_analysis.c code from ReplayGain.
gnormalize can also rip, (re)encode, convert audio formats between 
MP3, MP4, MPC, OGG, APE and FLAC, play audio files, and tag properties 
of the final normalized files.           

%prep                                                                             
%setup -q -a1 -a2
%{_bindir}/iconv -f iso8859-1 -t utf8 README -o README.txt
%patch0 -p0 -b .gnormalize-Audio-CD
%patch1 -p1 -b .gnormalize-mpc
%{__mv} README.txt README

%build
pushd WaveGain-1.2.6
make
popd

pushd Audio-CD-0.04
perl Makefile.PL INSTALLDIRS=vendor
make
popd

%install                                                                          
rm -rf %{buildroot} 
                                                           
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_datadir}/gnormalize/animations 
mkdir -p %{buildroot}%{_datadir}/pixmaps/%{name}
mkdir -p %{buildroot}%{_mandir}/man1

mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Name=Gnormalize
Comment=A ripper, an encoder and an audio converter
Exec=%{name} 
Icon=%{name}
Terminal=false
Type=Application
Categories=AudioVideo;Audio;AudioVideoEditing;
EOF

# install
%{_bindir}/lzma -d gnormalize.1.lzma
%{__install} -m 755 gnormalize                 %{buildroot}%{_bindir}/gnormalize
%{__install} -m 755 WaveGain-1.2.6/wavegain    %{buildroot}%{_bindir}/wavegain
%{__install} -m 644 animations/*.gif           %{buildroot}%{_datadir}/gnormalize/animations
%{__install} -m 644 gnormalize.1               %{buildroot}%{_mandir}/man1
pushd Audio-CD-0.04
make install DESTDIR=%{buildroot}
%{__chmod} 755 %{buildroot}%{perl_vendorarch}/auto/Audio/CD/CD.so
popd

# icons
%{__install} -m 644 icons/%{name}-48.png  %{buildroot}%{_datadir}/pixmaps/%{name}.png
%{__install} -m 644 icons/%{name}-32.png  %{buildroot}%{_datadir}/pixmaps/%{name}/%{name}-32.png
%{__install} -m 644 icons/%{name}-16.png  %{buildroot}%{_datadir}/pixmaps/%{name}/%{name}-16.png

%clean                                                                            
rm -rf %{buildroot} 
                                                                                  
%files                                                                            
%defattr(-,root,root)                                                             
%doc README

%{_bindir}/%{name}
%{_bindir}/wavegain
%{_datadir}/%{name}/*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.png 
%{_datadir}/pixmaps/%{name}/%{name}-32.png
%{_datadir}/pixmaps/%{name}/%{name}-16.png
%{_mandir}/man1/gnormalize.1.gz
%{_mandir}/man3/Audio::CD.3pm.gz
%{perl_vendorarch}/Audio
%{perl_vendorarch}/auto
%exclude %{perl_archlib}/perllocal.pod
%exclude %{perl_vendorarch}/auto/Audio/CD/.packlist
%exclude %{perl_vendorarch}/auto/Audio/CD/CD.bs
                                                             
%changelog

* Tue May 24 2011 Paulo Roma <roma@lcg.ufrj.br> 0.63-10
- Removed unsupported hint directive.

* Sun Nov 28 2010 Paulo Roma <roma@lcg.ufrj.br> 0.63-9
- Added Rec flac123, alsa-utils.
- Not requiring mppdec, mppenc anymore.

* Fri Nov 19 2010 Paulo Roma <roma@lcg.ufrj.br> 0.63-8
- Using mpcdec/mpcenc form musepack-tools sv8.

* Sat Jul 19 2008 Paulo Roma <roma@lcg.ufrj.br> 0.63-7
- Updated to 0.63
- Added Req lame.
- Providing perl-Audio-CD.

* Mon Jun 30 2008 Paulo Roma <roma@lcg.ufrj.br> 0.62-6
- Updated to 0.62
- Added Requirement vorbis-tools.
- Installing in vendor.
- Replaced %%{perl_sitearch} for %%{perl_vendorarch}.
- Patched original Audio-CD code.

* Wed Jun 04 2008 Paulo Roma <roma@lcg.ufrj.br> 0.61-5
- Updated to 0.61
- Compiled and installed wavegain.
- Reformated the man file, which has been provided as lzma.
- Changed description.
- Added Audio-CD.
- Set an arch again, because of wavegain and Audio-CD.

* Mon Mar 24 2008 Paulo Roma <roma@lcg.ufrj.br> 0.53-4
- Patched for playing ape files.

* Fri Feb 29 2008 Paulo Roma <roma@lcg.ufrj.br> 0.53-3
- Removed mppdec and mppenc.
- Arch is noarch now.

* Thu Feb 28 2008 Paulo Roma <roma@lcg.ufrj.br> 0.53-2
- Adapted spec file for Fedora.
- In fact, its BuildArch is i386, since it provides mppdec and mppenc.
- Added Requires(hint) for additional packages.

* Sun Dec 02 2007 Claudio F. S. Rodrigues  0.53-1
- Translation to French by Yaen Pujol.
- The ability to create artist and album subdirectories when ripping an
  Audio CD. For example, we can choose filename rip format "%%a/%%b/%%n-%%t".

* Wed Nov 22 2006 Claudio F. S. Rodrigues  0.52-1
- Bugfixes.

* Tue Sep 23 2006 Claudio F. S. Rodrigues  0.51-1
- Show the Scrolling Text on the vertical or horizontal direction.

* Sun Sep 03 2006 Claudio F. S. Rodrigues  0.50-1
- Bugfixe on strings values of set_popdown_strings 
  function (thanks to Björn C. Schaefer).
- Show/Hide file number, artist and track columns of playlist.
- Color for artists and albuns columns when a file is played.
- Changes on Interval and Step for Scrolling Text.

* Fri Mar 31 2006 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.49-1
- The possibility to change the Remaining Time color.
- Add a button to show/hide the progress bar.
- Make a Makefile.

* Mon Feb 20 2006 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.48-1
- Bug fixes.

* Wed Nov 13 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.47-1
- Bug fixes.

* Wed Oct 29 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.46-1
- Play APE format with the command: mac "song.ape"  - -d | play -t wav -

* Wed Oct 16 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.45-1
- The ability to select more than one album or artist by pressing control 
  key and mouse button.

* Wed Oct 09 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.44-1
- The ability to choose what columns to show on the playlist.

* Wed Oct 02 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.43-1
- Some color on playlist.
- The ability to remove the selected musics from playlist.
- Use the directory name for Album list if no album name is found.

* Wed Sep 25 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.42-1
- Save the playlist in the configuration file and show the playlist like Rhythmbox.
- The output directory can be selected.

* Wed Sep 20 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.41-1
- The ability to play MP3, MP4, MPC, OGG, FLAC and WAV format was added.
  gnormalize play MP3 with mpg321/mpg123/madplay, MPC with mppdec, 
  OGG with ogg123, FLAC with flac123/MPlayer and WAV with MPlayer.                              
- Convert/Normalize all supported files inside the directory to one specific format. 
- Output to WAV without need to encode.
- Change the cd player skin.

* Wed Sep 09 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.40-1
- The ability to select one skin to cd player was added.

* Wed Sep 07 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.39-1
- Only CD player display mode was added.

* Wed Aug 24 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.38-1
- More improve on the CD player display. 

* Mon Aug 20 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.37-1
- Set the relative audio track position on the CD player. 
                                                                  
* Mon Aug 15 2005 Claudio F. S. Rodrigues <claudiofsr@yahoo.com> 0.36-1
- First realease from gnormalize homepage.
- Initial specification file.                      
                                                                                                                               
                                                                                  
